// MatrixSample.cpp :  α׷   մϴ.
//

#include "stdafx.h"
#include "MatrixSample.h"

#define MAX_LOADSTRING 100

//  :
HINSTANCE hInst;								//  νϽԴϴ.
TCHAR szTitle[MAX_LOADSTRING];					//  ǥ ؽƮԴϴ.
TCHAR szWindowClass[MAX_LOADSTRING];			// ⺻ â Ŭ ̸Դϴ.

//  ڵ ⿡  ִ Լ  Դϴ.
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);




ID2D1Factory*				g_ipD2DFactory = nullptr;
ID2D1HwndRenderTarget*		g_ipRT = nullptr;
IWICImagingFactory*			g_ipWICFactory = nullptr;
IWICFormatConverter*		g_ipConvertedSrcBmp = nullptr;
ID2D1Bitmap*				g_ipD2DBitmap = nullptr;


void InitializeD2D( void )
{

	HRESULT hr = E_FAIL;

	//-----------------------------------------------------------------------
	//	D2D Factory  Ѵ.
	//-----------------------------------------------------------------------
	hr = ::D2D1CreateFactory( D2D1_FACTORY_TYPE_SINGLE_THREADED, 
							  &::g_ipD2DFactory );
	assert( hr == S_OK );

	//-----------------------------------------------------------------------
	//	Windows Imaging Component Factory  Ѵ.
	//-----------------------------------------------------------------------
	hr = ::CoCreateInstance( CLSID_WICImagingFactory,
							 NULL, CLSCTX_INPROC_SERVER,
							 IID_PPV_ARGS( &::g_ipWICFactory ) );
	assert( hr == S_OK );

}

void InitializeRT( HWND hWnd )
{	

	assert( ::g_ipRT == nullptr );
	assert( hWnd != 0 );

	HRESULT hr = E_FAIL;
	RECT rc;
	::GetClientRect( hWnd, &rc );
	

	D2D1_RENDER_TARGET_PROPERTIES dxRTProperties = ::D2D1::RenderTargetProperties();
	D2D1_SIZE_U dxSize = ::D2D1::SizeU( rc.right - rc.left,
										rc.bottom - rc.top );
	
	hr = ::g_ipD2DFactory->CreateHwndRenderTarget( dxRTProperties,
													::D2D1::HwndRenderTargetProperties( hWnd, dxSize ),
													&::g_ipRT );
	assert( hr == S_OK );
	
}


void CreateD2DBitmapFromFile( HWND hWnd, TCHAR* pImageFullPath )
{

	assert( pImageFullPath != nullptr );
	assert( ::g_ipWICFactory != nullptr );
	assert( ::g_ipRT != nullptr );

	HRESULT hr = E_FAIL;


	//----------------------------------------------------------------
	//	ڴ Ѵ.
	//----------------------------------------------------------------
	IWICBitmapDecoder* ipDecoderPtr = nullptr;
	hr = ::g_ipWICFactory->CreateDecoderFromFilename( pImageFullPath, nullptr,
													  GENERIC_READ,
													  WICDecodeMetadataCacheOnDemand,
													  &ipDecoderPtr );
	assert( hr == S_OK );

	//----------------------------------------------------------------
	//	ڴ  ´.
	//----------------------------------------------------------------
	IWICBitmapFrameDecode* ipFramePtr = nullptr;
	hr = ipDecoderPtr->GetFrame( 0, &ipFramePtr );
	assert( hr == S_OK );
	
	
	//----------------------------------------------------------------
	//	  ؼ  ͸ .
	//----------------------------------------------------------------
	SafeRelease( ::g_ipConvertedSrcBmp );
	hr = ::g_ipWICFactory->CreateFormatConverter( &::g_ipConvertedSrcBmp );
	assert( hr == S_OK );


	hr = ::g_ipConvertedSrcBmp->Initialize( ipFramePtr,
											GUID_WICPixelFormat32bppPBGRA,
											WICBitmapDitherTypeNone,
											nullptr,
											0.0f,
											WICBitmapPaletteTypeCustom );
	assert( hr == S_OK );

	//----------------------------------------------------------------
	//	Ʈ ͸  ؼ  Ʈ .
	//----------------------------------------------------------------
	SafeRelease( ::g_ipD2DBitmap );
	hr = ::g_ipRT->CreateBitmapFromWicBitmap( ::g_ipConvertedSrcBmp,
											  nullptr,
											  &::g_ipD2DBitmap );
	assert( hr == S_OK );

	SafeRelease( ipDecoderPtr );
	SafeRelease( ipFramePtr );



	
}




int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);


	HRESULT hr = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED | COINIT_DISABLE_OLE1DDE);

 	// TODO: ⿡ ڵ带 Էմϴ.
	MSG msg;
	HACCEL hAccelTable;

	//  ڿ ʱȭմϴ.
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MATRIXSAMPLE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	//  α׷ ʱȭ մϴ.
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_MATRIXSAMPLE));

	// ⺻ ޽ Դϴ.
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  Լ: MyRegisterClass()
//
//  : â Ŭ մϴ.
//
//  :
//
//    Windows 95 ߰ 'RegisterClassEx' Լ 
//    ش ڵ尡 Win32 ý۰ ȣȯǵ
//    Ϸ 쿡  Լ մϴ.  Լ ȣؾ
//    ش  α׷ 
//    'ùٸ '     ֽϴ.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MATRIXSAMPLE));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_MATRIXSAMPLE);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   Լ: InitInstance(HINSTANCE, int)
//
//   : νϽ ڵ ϰ  â ϴ.
//
//   :
//
//         Լ  νϽ ڵ   ϰ
//         α׷ â   ǥմϴ.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // νϽ ڵ   մϴ.

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }


   ::InitializeD2D();

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  Լ: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  :  â ޽ óմϴ.
//
//  WM_COMMAND	-  α׷ ޴ óմϴ.
//  WM_PAINT	-  â ׸ϴ.
//  WM_DESTROY	-  ޽ Խϰ ȯմϴ.
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// ޴   мմϴ.
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;

	case WM_SIZE :
		{
			::InitializeRT( hWnd );
			//::AutoLoadImages( hWnd );
			RECT rc = { 0, 0, 10, 10 };
			::CreateD2DBitmapFromFile( hWnd, _T( "Images/aaa.jpg" ) );
			::InvalidateRect( hWnd, NULL, TRUE );
		}
		break;

	case WM_PAINT:
		{

			D2D1::Matrix3x2F matTranslation;
			D2D1::Matrix3x2F matRot;
			D2D1::Matrix3x2F matTM;

			hdc = BeginPaint(hWnd, &ps);	

			::D2D1_RECT_F dxArea = ::D2D1::RectF( 0.0f, 0.0f, 200.0f, 200.0f );

			HRESULT hr = E_FAIL;
			::g_ipRT->BeginDraw();
			::g_ipRT->Clear( ::D2D1::ColorF( ::D2D1::ColorF::White ) );

			matTranslation = ::D2D1::Matrix3x2F::Translation( 20.0f, 20.0f );
			::g_ipRT->SetTransform( matTranslation );					
			::g_ipRT->DrawBitmap( ::g_ipD2DBitmap, dxArea );	
			
			
			//---------------------------------------------------------------------
			//	 ȯ Ģ   ִ κ
			//---------------------------------------------------------------------
			matTranslation = ::D2D1::Matrix3x2F::Translation( 20.0f, 220.0f );		
			matRot = ::D2D1::Matrix3x2F::Rotation( -30.0f, D2D1::Point2F( 120.0f, 320.0f ) );
			matTM = matTranslation * matRot;			
			::g_ipRT->SetTransform( matTM );													
			::g_ipRT->DrawBitmap( ::g_ipD2DBitmap, dxArea );	


			matTranslation = ::D2D1::Matrix3x2F::Translation( 300.0f, 220.0f );		
			matRot = ::D2D1::Matrix3x2F::Rotation( -30.0f, D2D1::Point2F( 400.0f, 320.0f ) );
			//matTM = matRot * matTranslation;						
			matTM = matTranslation * matRot;
			::g_ipRT->SetTransform( matTM );													
			::g_ipRT->DrawBitmap( ::g_ipD2DBitmap, dxArea );
			//---------------------------------------------------------------------
			//	
			//---------------------------------------------------------------------
			


			hr = ::g_ipRT->EndDraw();				
		}
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

//  ȭ  ޽ óԴϴ.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
